
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import net.proteanit.sql.DbUtils;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Gaurav
 */
public class Subject extends javax.swing.JPanel {

    /**
     * Creates new form Subject
     */
    Connection conn;
    ResultSet rs;
    PreparedStatement ps;
   
      
    public Subject() {
        initComponents();
        conn = MySQLConnect.getConnection();
     
        setBranch();
        fillDataTable();

        txtSubjectId.setVisible(false);

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollBar1 = new javax.swing.JScrollBar();
        jPanel1 = new javax.swing.JPanel();
        lblheader = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txtSubjectId = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        j = new javax.swing.JScrollPane();
        jtbSubject = new javax.swing.JTable();
        txtsearchdata = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        txtSubjectName = new javax.swing.JTextField();
        cmbSemester = new javax.swing.JComboBox<>();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel7 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        cmbTeacher = new javax.swing.JComboBox<>();
        jLabel8 = new javax.swing.JLabel();
        cmbBranch = new javax.swing.JComboBox<>();
        jPanel4 = new javax.swing.JPanel();
        jLabel6 = new javax.swing.JLabel();
        txtsearch = new javax.swing.JTextField();
        jSeparator3 = new javax.swing.JSeparator();
        lbladd = new javax.swing.JLabel();
        lblUpdate = new javax.swing.JLabel();
        lbldelete = new javax.swing.JLabel();
        lblDelete = new javax.swing.JLabel();
        lblAdd = new javax.swing.JLabel();

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jPanel1.setPreferredSize(new java.awt.Dimension(880, 680));

        lblheader.setBackground(new java.awt.Color(255, 255, 255));
        lblheader.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));
        lblheader.setPreferredSize(new java.awt.Dimension(880, 80));

        jLabel1.setFont(new java.awt.Font("SansSerif", 0, 30)); // NOI18N
        jLabel1.setText("Manage Subjects");

        javax.swing.GroupLayout lblheaderLayout = new javax.swing.GroupLayout(lblheader);
        lblheader.setLayout(lblheaderLayout);
        lblheaderLayout.setHorizontalGroup(
            lblheaderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(lblheaderLayout.createSequentialGroup()
                .addGap(143, 143, 143)
                .addComponent(jLabel1)
                .addGap(182, 182, 182)
                .addComponent(txtSubjectId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(315, Short.MAX_VALUE))
        );
        lblheaderLayout.setVerticalGroup(
            lblheaderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(lblheaderLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(lblheaderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtSubjectId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBackground(new java.awt.Color(255, 255, 255));

        j.setBackground(new java.awt.Color(255, 255, 255));

        jtbSubject.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jtbSubject.setGridColor(new java.awt.Color(255, 255, 255));
        jtbSubject.setSelectionBackground(new java.awt.Color(66, 133, 140));
        jtbSubject.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jtbSubjectMouseClicked(evt);
            }
        });
        j.setViewportView(jtbSubject);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(j, javax.swing.GroupLayout.PREFERRED_SIZE, 880, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addComponent(j, javax.swing.GroupLayout.PREFERRED_SIZE, 200, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        txtsearchdata.setBackground(new java.awt.Color(255, 255, 255));
        txtsearchdata.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));

        jLabel2.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        jLabel2.setText("Subject Name");

        txtSubjectName.setBorder(null);

        cmbSemester.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        cmbSemester.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "first", "second", "third", "fourth", "fifth", "sixth" }));
        cmbSemester.setSelectedIndex(-1);
        cmbSemester.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbSemesterActionPerformed(evt);
            }
        });

        jLabel7.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel7.setText("Teacher");

        jLabel5.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        jLabel5.setText("Semester");

        jLabel8.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel8.setText("Branch");

        cmbBranch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbBranchActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout txtsearchdataLayout = new javax.swing.GroupLayout(txtsearchdata);
        txtsearchdata.setLayout(txtsearchdataLayout);
        txtsearchdataLayout.setHorizontalGroup(
            txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(txtsearchdataLayout.createSequentialGroup()
                .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, txtsearchdataLayout.createSequentialGroup()
                        .addGap(123, 123, 123)
                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(txtsearchdataLayout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(txtsearchdataLayout.createSequentialGroup()
                                .addComponent(jLabel5)
                                .addGap(48, 48, 48)
                                .addComponent(cmbSemester, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(txtsearchdataLayout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(txtSubjectName, javax.swing.GroupLayout.PREFERRED_SIZE, 220, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addGap(83, 83, 83)
                .addComponent(jLabel7)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cmbTeacher, javax.swing.GroupLayout.PREFERRED_SIZE, 241, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(62, Short.MAX_VALUE))
            .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, txtsearchdataLayout.createSequentialGroup()
                    .addContainerGap(430, Short.MAX_VALUE)
                    .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(313, 313, 313)))
            .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, txtsearchdataLayout.createSequentialGroup()
                    .addContainerGap(517, Short.MAX_VALUE)
                    .addComponent(cmbBranch, javax.swing.GroupLayout.PREFERRED_SIZE, 241, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGap(62, 62, 62)))
        );
        txtsearchdataLayout.setVerticalGroup(
            txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, txtsearchdataLayout.createSequentialGroup()
                .addGap(17, 17, 17)
                .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtSubjectName, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(19, 19, 19)
                .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cmbSemester, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5)
                    .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(cmbTeacher, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(25, Short.MAX_VALUE))
            .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(txtsearchdataLayout.createSequentialGroup()
                    .addGap(27, 27, 27)
                    .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGap(80, 80, 80)))
            .addGroup(txtsearchdataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(txtsearchdataLayout.createSequentialGroup()
                    .addGap(27, 27, 27)
                    .addComponent(cmbBranch, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(74, Short.MAX_VALUE)))
        );

        jPanel4.setBackground(new java.awt.Color(255, 255, 255));
        jPanel4.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));

        jLabel6.setFont(new java.awt.Font("SansSerif", 0, 18)); // NOI18N
        jLabel6.setText("Search");

        txtsearch.setBorder(null);
        txtsearch.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtsearchKeyPressed(evt);
            }
        });

        jSeparator3.setForeground(new java.awt.Color(0, 0, 0));

        lbladd.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblUpdate.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/Update (1).png"))); // NOI18N
        lblUpdate.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        lblUpdate.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lblUpdateMouseClicked(evt);
            }
        });

        lbldelete.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));

        lblDelete.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/delete.png"))); // NOI18N
        lblDelete.setText("jLabel4");
        lblDelete.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lblDeleteMouseClicked(evt);
            }
        });

        lblAdd.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/ADD.png"))); // NOI18N
        lblAdd.setText("jLabel8");
        lblAdd.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lblAddMouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addComponent(jLabel6)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 194, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(48, 48, 48)
                        .addComponent(lbladd))
                    .addComponent(txtsearch, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(9, 9, 9)
                .addComponent(lblAdd, javax.swing.GroupLayout.PREFERRED_SIZE, 114, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(63, 63, 63)
                .addComponent(lblUpdate)
                .addGap(48, 48, 48)
                .addComponent(lblDelete, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(147, 147, 147)
                .addComponent(lbldelete))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(99, 99, 99)
                        .addComponent(lbladd))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(50, 50, 50)
                        .addComponent(lbldelete)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblUpdate, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(txtsearch, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel6)
                        .addComponent(lblAdd))
                    .addComponent(lblDelete, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(0, 0, 0)
                .addComponent(jSeparator3, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(28, 28, 28))
        );

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(lblheader, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, 852, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(15, 15, 15))
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(31, 31, 31)
                .addComponent(txtsearchdata, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(lblheader, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26)
                .addComponent(txtsearchdata, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(33, 33, 33)
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(32, 32, 32))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 882, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, 657, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cmbSemesterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbSemesterActionPerformed
        // TODO add your handling code here:
        cmbTeacher.removeAllItems();
         setTeacher();
    }//GEN-LAST:event_cmbSemesterActionPerformed

    private void lblUpdateMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lblUpdateMouseClicked
        // TODO add your handling code here:
        updateSubject();
    }//GEN-LAST:event_lblUpdateMouseClicked

    private void cmbBranchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbBranchActionPerformed
        // TODO add your handling code here:
       
    }//GEN-LAST:event_cmbBranchActionPerformed

    private void lblAddMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lblAddMouseClicked
        // TODO add your handling code here:
        insertSubject();
    }//GEN-LAST:event_lblAddMouseClicked

    private void jtbSubjectMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jtbSubjectMouseClicked
        // TODO add your handling code here:
         int getSelectedRow = jtbSubject.getSelectedRow();
        String subject_id = jtbSubject.getValueAt(getSelectedRow,0).toString();

        String query = "Select * from subject where subject_id ='"+subject_id+"'";
        try {
            ps = conn.prepareStatement(query);
            rs = ps.executeQuery();
            if(rs.next()){
                txtSubjectId.setText(rs.getString("subject_id"));
                txtSubjectName.setText(rs.getString("subject_name"));
                
            }
        } catch (SQLException ex) {
            Logger.getLogger(Branch.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jtbSubjectMouseClicked

    private void lblDeleteMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lblDeleteMouseClicked
        // TODO add your handling code here:
         int ans = JOptionPane.showConfirmDialog(this,"Are you sure you want to delete this record?",
                "Delete!",JOptionPane.YES_NO_OPTION);
        
        if(ans == JOptionPane.YES_OPTION){
        String str = "delete from subject where subject_id="+txtSubjectId.getText();
        try{
         ps = conn.prepareStatement(str);
         ps.execute();
          JOptionPane.showMessageDialog(null,"Deleted");
          fillDataTable();
        } catch (SQLException ex) {
             JOptionPane.showMessageDialog(null,"Insert Error"+ex);
            Logger.getLogger(Subject.class.getName()).log(Level.SEVERE, null, ex);
        }
        }
    }//GEN-LAST:event_lblDeleteMouseClicked

    private void txtsearchKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtsearchKeyPressed
        // TODO add your handling code here:
         String temp =txtsearch.getText();
         String query = "Select * from subject where subject_name like '"+temp+"%'";
        try {
            ps = conn.prepareStatement(query);
            rs = ps.executeQuery();
          
//                jtbBranchinfo.removeAll();
              jtbSubject.setModel(getMyTableModel(DbUtils.resultSetToTableModel(rs)));
            
        } catch (SQLException ex) {
            Logger.getLogger(Branch.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_txtsearchKeyPressed
    private void insertSubject(){
        String sql = "INSERT INTO subject(subject_name,branch_id,semester_id,teacher_id) VALUE(?,?,?,?)";
        String name = txtSubjectName.getText();
        int branch = getBranchId();
        int sem = getSemesterId();
        int teacher = getTeacherId();
        
        try{
            ps = conn.prepareStatement(sql);
            ps.setString(1, name);
            ps.setInt(2, branch);
            ps.setInt(3, sem);
            ps.setInt(4, teacher);
           
            ps.execute();
        }catch(SQLException e){
            JOptionPane.showMessageDialog(null,"Insert Error"+e);
        }
        
        
         JOptionPane.showMessageDialog(null,"Insert sucess");
    }
    void updateSubject(){
        String name = txtSubjectName.getText();
        int branch = getBranchId();
        int sem = getSemesterId();
        int teacher = getTeacherId();
        System.out.println(getTeacherId());
         String sql = "update subject set subject_name=?, branch_id =?, semester_id =?,teacher_id =? where subject_id ="+txtSubjectId.getText();
         try{
            ps = conn.prepareStatement(sql);
            ps.setString(1, name);
            ps.setInt(2, branch);
            ps.setInt(3, sem);
            ps.setInt(4, teacher);
            ps.execute();
            fillDataTable();
            JOptionPane.showMessageDialog(null,"data updated sucessfully");
         }catch(SQLException e){
              JOptionPane.showMessageDialog(null,"data updated unsucessfully "+e);
         }
    }
    private void setBranch(){
        String query = "select branch_name from branch";
        
        try {
            ps = conn.prepareStatement(query);
            rs = ps.executeQuery();
            while(rs.next()){
                cmbBranch.addItem(rs.getString("branch_name"));
               
            }
        } catch (SQLException ex) {
           
        }
    }
    private int getBranchId(){
    int branch_id = 0;
    String branch_n = cmbBranch.getSelectedItem().toString();
    String query = "Select * from branch where branch_name = ?";
        try {
            ps = conn.prepareStatement(query);
            ps.setString(1,branch_n);
            rs = ps.executeQuery();
            if(rs.next()){
                branch_id = rs.getInt("branch_id");
            }
        } catch (SQLException ex) {
            
        }
   return branch_id;
}
    private int getSemesterId(){
    int index= cmbSemester.getSelectedIndex();
    int sem_id = index + 1;
    return sem_id;
}
    private int getSubjectId(){
        int subject_id= 0;
        int row = jtbSubject.getSelectedRow();
        String subject_name = (String) jtbSubject.getValueAt(row, 0);
        System.out.println(subject_name);
        String query = "Select subject_id from subject where subject_name =?";
        try {
            ps = conn.prepareStatement(query);
            ps.setString(1,subject_name);
            rs = ps.executeQuery();
            if(rs.next()){
                subject_id = rs.getInt("subject_id");
            }
        } catch (SQLException ex) {
            
        
        }
    return subject_id;
}
    
     private void setTeacher(){
//         System.out.println(getBranchId());

        String query = "select teacher_name from teacher where branch_id ="+getBranchId();
        
        try {
            ps = conn.prepareStatement(query);
            rs = ps.executeQuery();
            while(rs.next()){
                cmbTeacher.addItem(rs.getString("teacher_name"));
               
            }
        } catch (SQLException ex) {
           
        }
    }
    
 private int getTeacherId(){
    int teacher_id = 0;
    String teacher = cmbTeacher.getSelectedItem().toString();
    System.out.println(teacher);
    String query = "Select * from teacher where teacher_name ='"+teacher+"'";
        try {
            ps = conn.prepareStatement(query);
//            ps.setString(1,teacher);
            rs = ps.executeQuery();
            if(rs.next()){
                teacher_id = rs.getInt("teacher_id");
                System.out.println("inside "+teacher_id);
            }
        } catch (SQLException ex) {
            
        }
   return teacher_id;
}
     private void clearFields(){
        txtSubjectName.setText("");
        cmbTeacher.setSelectedIndex(0);
        cmbSemester.setSelectedIndex(0);
        cmbTeacher.setSelectedIndex(0);
    }
     
    private void fillDataTable(){
        String query = "SELECT subject_id,subject_name,branch_name,semester_id,teacher_name FROM subject join teacher on subject.teacher_id = teacher.teacher_id join branch on subject.branch_id = branch.branch_id   ";
        try {
            ps = conn.prepareStatement(query);
           
            rs = ps.executeQuery();
            jtbSubject.setModel(getMyTableModel(DbUtils.resultSetToTableModel(rs)));
        } catch (SQLException ex) {
            Logger.getLogger(Branch.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
       private DefaultTableModel getMyTableModel(TableModel dtm){
        int row = dtm.getRowCount();
        int col = dtm.getColumnCount();
        Object[][] jTableData = new Object[row][col];
        for(int i = 0;i<row;i++){
            for(int j = 0;j<col;j++){
                jTableData[i][j] = dtm.getValueAt(i, j);
            }
        }
        String[] colHeads = {"subject_id","Subject_name","Branch_name","Semester_id","teacher_name"};
        DefaultTableModel myModel;
        myModel = new DefaultTableModel(jTableData,colHeads){
            
            @Override
            public boolean isCellEditable(int row, int column){
                return false;
            }
        };
         return myModel;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> cmbBranch;
    private javax.swing.JComboBox<String> cmbSemester;
    private javax.swing.JComboBox<String> cmbTeacher;
    private javax.swing.JScrollPane j;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollBar jScrollBar1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator3;
    private javax.swing.JTable jtbSubject;
    private javax.swing.JLabel lblAdd;
    private javax.swing.JLabel lblDelete;
    private javax.swing.JLabel lblUpdate;
    private javax.swing.JLabel lbladd;
    private javax.swing.JLabel lbldelete;
    private javax.swing.JPanel lblheader;
    private javax.swing.JTextField txtSubjectId;
    private javax.swing.JTextField txtSubjectName;
    private javax.swing.JTextField txtsearch;
    private javax.swing.JPanel txtsearchdata;
    // End of variables declaration//GEN-END:variables
}
